var lock_bet = false;
var lock_flipped = false;

function reset() {
  // Reset
  jQuery(".dealer-cards").html("<div class='card card1 flipped'></div><div class='card card2 flipped'></div><div class='new-cards'></div><div class='clear'></div><div id='dealerTotal' class='dealer-total'></div>");

  jQuery(".player-cards").html("<div class='card card1 flipped'></div><div class='card card2 flipped'></div><div class='new-cards'></div><div class='clear'></div><div id='playerTotal' class='player-total'></div>");

  var reloadGame = "<div class='btn' id='deal'>...</div>";
  jQuery(".buttons").html(reloadGame);

  jQuery(".dealer-cards").css("width", "");
  jQuery(".player-cards").css("width", "");

  jQuery("#playerTotal").html('');
  jQuery("#dealerTotal").html('');
  jQuery("#message").html(''); 
  
	document.getElementById("result").style.display = 'none';
	hide_save();
	lock_bet = false;
}
 
 function hide_save() {
	document.getElementById("lbl_winner").style.display = 'none';
	document.getElementById("winner").style.display = 'none';
	document.getElementById("save_result").style.display = 'none';
 }
 
 function check_hiscore(value) {
	var hiscore_01 = parseInt(document.getElementById("hiscore_01").innerHTML);
	var hiscore_02 = parseInt(document.getElementById("hiscore_02").innerHTML);
	var hiscore_03 = parseInt(document.getElementById("hiscore_03").innerHTML);
	
	if (!hiscore_01) {
		hiscore_01 = 0;
	}
	if (!hiscore_02) {
		hiscore_02 = 0;
	}
	if (!hiscore_03) {
		hiscore_03 = 0;
	}	
	
	if (value > hiscore_01 || value > hiscore_02 || value > hiscore_03) {
		document.getElementById('result').value = value;
		document.getElementById("lbl_winner").style.display = 'initial';
		document.getElementById("winner").style.display = 'initial';
		document.getElementById("save_result").style.display = 'initial';
	}
 }

function deal() {

  reset();
	var bet = jQuery("#bet").html();
	if (bet == '0') {return false;} 
	lock_bet = true;
	jQuery(".dealer-cards").html("<div class='card card1'></div><div class='card card2 flipped'></div><div class='new-cards'></div><div class='clear'></div><div id='dealerTotal' class='dealer-total'></div>");
	jQuery(".player-cards").html("<div class='card card1'></div><div class='card card2'></div><div class='new-cards'></div><div class='clear'></div><div id='playerTotal' class='player-total'></div>");
	var reloadGame = "<div class='btn' id='hit'>Hit</div><div class='btn' id='stand'>Stand</div>";
	jQuery(".buttons").html(reloadGame);
  
// Store cards in array
  var cards = ["ace-of-clubs", "two-of-clubs", "three-of-clubs", "four-of-clubs", "five-of-clubs", "six-of-clubs", "seven-of-clubs", "eight-of-clubs", "nine-of-clubs", "ten-of-clubs", "jack-of-clubs", "queen-of-clubs", "king-of-clubs", "ace-of-spades", "two-of-spades", "three-of-spades", "four-of-spades", "five-of-spades", "six-of-spades", "seven-of-spades", "eight-of-spades", "nine-of-spades", "ten-of-spades", "jack-of-spades", "queen-of-spades", "king-of-spades", "ace-of-hearts", "two-of-hearts", "three-of-hearts", "four-of-hearts", "five-of-hearts", "six-of-hearts", "seven-of-hearts", "eight-of-hearts", "nine-of-hearts", "ten-of-hearts", "jack-of-hearts", "queen-of-hearts", "king-of-hearts", "ace-of-diamonds", "two-of-diamonds", "three-of-diamonds", "four-of-diamonds", "five-of-diamonds", "six-of-diamonds", "seven-of-diamonds", "eight-of-diamonds", "nine-of-diamonds", "ten-of-diamonds", "jack-of-diamonds", "queen-of-diamonds", "king-of-diamonds"];

  // Store correlating values in an array
  var values = [11, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10, 11, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10, 11, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10, 11, 2, 3, 4, 5, 6, 7, 8, 9, 10, 10, 10, 10];

  // Zero out dealer total
  var dealerTotal = 0;
  jQuery(".dealer-cards .card").each(function() {

    var num = Math.floor(Math.random() * cards.length);
    var cardClass = cards[num];

    jQuery(this).addClass(cardClass);

    jQuery(this).attr("data-value", values[num]);

    dealerTotal = parseInt(dealerTotal) + parseInt(values[num]);

    if (dealerTotal > 21) {
      jQuery(".dealer-cards .card").each(function() {
        if (jQuery(this).attr("data-value") == 11) {
          dealerTotal = parseInt(dealerTotal) - 10;
          jQuery(this).attr("data-value", 1);
        }
      });
    }

    jQuery("#dealerTotal").html(dealerTotal);

    cards.splice(num, 1);
    values.splice(num, 1);
  });

  // Zero out player total
  var playerTotal = 0;
  jQuery(".player-cards .card").each(function() {

    var num = Math.floor(Math.random() * cards.length);
    var cardClass = cards[num];

    jQuery(this).addClass(cardClass);

    jQuery(this).attr("data-value", values[num]);

    playerTotal = parseInt(playerTotal) + parseInt(values[num]);

    if (playerTotal > 21) {
      jQuery(".player-cards .card").each(function() {
        if (jQuery(this).attr("data-value") == 11) {
          playerTotal = parseInt(playerTotal) - 10;
          jQuery(this).attr("data-value", 1);
        }
      });
    }

    jQuery("#playerTotal").html(playerTotal);

    cards.splice(num, 1);
    values.splice(num, 1);

  });


  // If player hits
  jQuery("#hit").click(function() {
	  lock_bet = true;

    var num = Math.floor(Math.random() * cards.length);
    var cardClass = cards[num];

    var newCard = "<div class='card " + cardClass + "' data-value='" + values[num] + "'></div>";
    jQuery(".player-cards .new-cards").append(newCard);

    playerTotal = parseInt(playerTotal) + parseInt(values[num]);

    if (playerTotal > 21) {
      jQuery(".player-cards .card").each(function() {
        if (jQuery(this).attr("data-value") == 11) {
          playerTotal = parseInt(playerTotal) - 10;
          jQuery(this).attr("data-value", 1);
        }
      });
    }

    cards.splice(num, 1);
    values.splice(num, 1);

    jQuery("#playerTotal").html(playerTotal);
    jQuery(".player-cards").width(jQuery(".player-cards").width() + 84);


    if (playerTotal > 21) {
      jQuery("#message").html('Bust!');
      var reloadGame = "<div class='btn' id='deal'>New Game</div>";
      jQuery(".buttons").html(reloadGame);
      // Pay up
      jQuery("#bet").html('0');
lock_bet = false;
      return false;
    }


  });

  // If player stands
  jQuery("#stand").click(function() {

    jQuery("#dealerTotal").css("visibility", "visible");
    jQuery(".card2").removeClass("flipped");

    // Keep adding a card until over 17 or dealer busts
    var keepDealing = setInterval(function() {

      var dealerTotal = jQuery("#dealerTotal").html();
      var playerTotal = jQuery("#playerTotal").html();

      // If there are aces
      if (dealerTotal > 21) {
        jQuery(".dealer-cards .card").each(function() {

          // and check if still over 21 in the loop
          if (jQuery(this).attr("data-value") == 11 && dealerTotal > 21) {
            dealerTotal = parseInt(dealerTotal) - 10;
            jQuery(this).attr("data-value", 1);
          }
        });
      }

      if (dealerTotal > 21) {
        jQuery("#message").html('Dealer Bust!');
        var reloadGame = "<div class='btn' id='deal'>New Game</div>";
        jQuery(".buttons").html(reloadGame);
        clearInterval(keepDealing);
        // Pay up
        var bet = jQuery("#bet").html();
        var money = jQuery("#money").html();
        var winnings = bet * 2;
        jQuery("#bet").html('0');
        jQuery("#money").html(parseInt(winnings) + parseInt(money));
		
		check_hiscore(parseInt(winnings) + parseInt(money));
		lock_bet = false;
        return false;
      }


      if (dealerTotal >= 17) {
        // You Win
        if (playerTotal > dealerTotal) {

          jQuery("#message").html('You Win!!!');

          // Pay up
          var bet = jQuery("#bet").html();
          var money = jQuery("#money").html();
          var winnings = bet * 2;
          jQuery("#bet").html('0');
          jQuery("#money").html(parseInt(winnings) + parseInt(money));
		  lock_bet = false;
		  
		  check_hiscore(parseInt(winnings) + parseInt(money));
        }

        // You Lose
        if (playerTotal < dealerTotal) {

          jQuery("#message").html('You Lose!');
          // Pay up
          var bet = jQuery("#bet").html();
          var money = jQuery("#money").html();
          jQuery("#bet").html('0');
          jQuery("#money").html(parseInt(money) - parseInt(bet));
        }
        if (playerTotal == dealerTotal) {
          jQuery("#message").html('Push!');
          var bet = jQuery("#bet").html();
          var money = jQuery("#money").html();
          jQuery("#money").html(parseInt(bet) + parseInt(money));
          jQuery("#bet").html('0');
        }
        var reloadGame = "<div class='btn' id='deal'>New Game</div>";
        jQuery(".buttons").html(reloadGame);
        clearInterval(keepDealing);
		lock_bet = false;
        return false;
      }

      var num = Math.floor(Math.random() * cards.length);
      var cardClass = cards[num];

      var newCard = "<div class='card " + cardClass + "' data-value='" + values[num] + "'></div>";
      jQuery(".dealer-cards .new-cards").append(newCard);

      dealerTotal = parseInt(dealerTotal) + parseInt(values[num]);

      jQuery("#dealerTotal").html(dealerTotal);
      jQuery(".dealer-cards").width(jQuery(".dealer-cards").width() + 84)


      cards.splice(num, 1);
      values.splice(num, 1);

    }, 300);
  });
}

jQuery(document).ready(function() {

  deal();


  // Bet
  jQuery("#more100").click(function() {
if (lock_bet == true) {return false;}
var reloadGame = "<div class='btn' id='deal'>Deal</div>";
jQuery(".buttons").html(reloadGame);

	hide_save();

    var bet = 100;
    var currentBet = jQuery("#bet").html();
    var money = jQuery("#money").html();
    if (money <= 0)
      return false;
    if (currentBet) {

      jQuery("#bet").html(parseInt(currentBet) + bet);

    } else {

      jQuery("#bet").html(bet);

    }

    jQuery("#money").html(money - bet);

  });  
  
  jQuery("#more").click(function() {
if (lock_bet == true) {return false;}
var reloadGame = "<div class='btn' id='deal'>Deal</div>";
jQuery(".buttons").html(reloadGame);
    hide_save();
	
	var bet = 10;
    var currentBet = jQuery("#bet").html();
    var money = jQuery("#money").html();
    if (money <= 0)
      return false;
    if (currentBet) {

      jQuery("#bet").html(parseInt(currentBet) + bet);

    } else {

      jQuery("#bet").html(bet);

    }

    jQuery("#money").html(money - bet);

  });

  jQuery("#less").click(function() {
if (lock_bet == true) {return false;}
var reloadGame = "<div class='btn' id='deal'>Deal</div>";
jQuery(".buttons").html(reloadGame);
    hide_save();
	
	var bet = -10;
    var currentBet = jQuery("#bet").html();
    if (currentBet == 0)
      return false;

    var money = jQuery("#money").html();

    if (currentBet) {

      jQuery("#bet").html(parseInt(currentBet) + bet);

    } else {

      jQuery("#bet").html(bet);

    }

    jQuery("#money").html(money - bet);

  });
  jQuery("#less100").click(function() {
if (lock_bet == true) {return false;}
var reloadGame = "<div class='btn' id='deal'>Deal</div>";
jQuery(".buttons").html(reloadGame);
    hide_save();
	
	var bet = -100;
    var currentBet = jQuery("#bet").html();
    if (currentBet == 0)
      return false;

    var money = jQuery("#money").html();

    if (currentBet) {

      jQuery("#bet").html(parseInt(currentBet) + bet);

    } else {

      jQuery("#bet").html(bet);

    }

    jQuery("#money").html(money - bet);

  });


  setInterval(function() {
    jQuery("#deal").unbind('click');
    jQuery("#deal").click(function() {
      // location.reload();
      deal();
    });
  }, 200);


});
